commit 702cfaf11c336889d77910b111ccdf21912cb573
Author: Andreas Müller <a.mueller@bgbm.org>
Date:   Tue Apr 4 22:29:01 2017 +0200

    ref #6286 FloraHellenica image import class added

diff --git a/app-import/src/main/java/eu/etaxonomy/cdm/app/greece/FloraHellenicaActivator.java b/app-import/src/main/java/eu/etaxonomy/cdm/app/greece/FloraHellenicaActivator.java
index dea67238..60da11a1 100644
--- a/app-import/src/main/java/eu/etaxonomy/cdm/app/greece/FloraHellenicaActivator.java
+++ b/app-import/src/main/java/eu/etaxonomy/cdm/app/greece/FloraHellenicaActivator.java
@@ -37,8 +37,8 @@ public class FloraHellenicaActivator {
     static DbSchemaValidation hbm2dll = DbSchemaValidation.CREATE;
 
 //    static final ICdmDataSource cdmDestination = CdmDestinations.localH2();
-  static final ICdmDataSource cdmDestination = CdmDestinations.cdm_test_local_mysql_test();
-//    static final ICdmDataSource cdmDestination = CdmDestinations.cdm_greece_checklist_production();
+//  static final ICdmDataSource cdmDestination = CdmDestinations.cdm_test_local_mysql_test();
+    static final ICdmDataSource cdmDestination = CdmDestinations.cdm_greece_checklist_production();
 
     //feature tree uuid
     public static final UUID featureTreeUuid = UUID.fromString("9e1e0e81-7475-4b28-8619-b7f42cd760b6");
@@ -52,6 +52,8 @@ public class FloraHellenicaActivator {
     //check - import
     static final CHECK check = CHECK.IMPORT_WITHOUT_CHECK;
 
+    boolean doImages = true;
+
     boolean doVocabularies = (hbm2dll == DbSchemaValidation.CREATE);
 
     private void doImport(ICdmDataSource cdmDestination){
@@ -70,6 +72,7 @@ public class FloraHellenicaActivator {
 //        config.setDoVocabularies(doVocabularies);
         config.setUuidFeatureTree(featureTreeUuid);
         config.setFeatureTreeTitle(featureTreeTitle);
+        config.setDoImages(doImages);
 
         CdmDefaultImport<FloraHellenicaImportConfigurator> myImport = new CdmDefaultImport<>();
         myImport.invoke(config);
diff --git a/app-import/src/main/java/eu/etaxonomy/cdm/io/greece/FloraHellenicaImageImport.java b/app-import/src/main/java/eu/etaxonomy/cdm/io/greece/FloraHellenicaImageImport.java
new file mode 100644
index 00000000..42ba8b22
--- /dev/null
+++ b/app-import/src/main/java/eu/etaxonomy/cdm/io/greece/FloraHellenicaImageImport.java
@@ -0,0 +1,57 @@
+/**
+* Copyright (C) 2016 EDIT
+* European Distributed Institute of Taxonomy
+* http://www.e-taxonomy.eu
+*
+* The contents of this file are subject to the Mozilla Public License Version 1.1
+* See LICENSE.TXT at the top of this package for the full license terms.
+*/
+package eu.etaxonomy.cdm.io.greece;
+
+import org.apache.log4j.Logger;
+import org.springframework.stereotype.Component;
+
+import eu.etaxonomy.cdm.io.common.CdmImportBase;
+import eu.etaxonomy.cdm.io.mexico.SimpleExcelTaxonImportState;
+
+/**
+ * Import for the Flora Hellenica images.
+ *
+ * @author a.mueller
+ * @date 03.04.2017
+ */
+
+@Component
+public class FloraHellenicaImageImport<CONFIG extends FloraHellenicaImportConfigurator>
+        extends CdmImportBase<CONFIG,SimpleExcelTaxonImportState<CONFIG>>{
+
+    private static final long serialVersionUID = 7118028793298922703L;
+    private static final Logger logger = Logger.getLogger(FloraHellenicaImageImport.class);
+
+    /**
+     * {@inheritDoc}
+     */
+    @Override
+    protected void doInvoke(SimpleExcelTaxonImportState<CONFIG> state) {
+//        String baseURI =
+    }
+
+    /**
+     * {@inheritDoc}
+     */
+    @Override
+    protected boolean doCheck(SimpleExcelTaxonImportState<CONFIG> state) {
+        return false;
+    }
+
+    /**
+     * {@inheritDoc}
+     */
+    @Override
+    protected boolean isIgnore(SimpleExcelTaxonImportState<CONFIG> state) {
+        return ! state.getConfig().isDoImages();
+    }
+
+
+
+}
diff --git a/app-import/src/main/java/eu/etaxonomy/cdm/io/greece/FloraHellenicaImportConfigurator.java b/app-import/src/main/java/eu/etaxonomy/cdm/io/greece/FloraHellenicaImportConfigurator.java
index 90f79c08..95aed726 100644
--- a/app-import/src/main/java/eu/etaxonomy/cdm/io/greece/FloraHellenicaImportConfigurator.java
+++ b/app-import/src/main/java/eu/etaxonomy/cdm/io/greece/FloraHellenicaImportConfigurator.java
@@ -29,6 +29,9 @@ public class FloraHellenicaImportConfigurator extends ExcelImportConfiguratorBas
     private static IInputTransformer defaultTransformer = new FloraHellenicaTransformer();
     private Reference secReference;
 
+    private boolean isDoImages = true;
+
+
 
     /**
      * @param source
@@ -59,6 +62,17 @@ public class FloraHellenicaImportConfigurator extends ExcelImportConfiguratorBas
                 FloraHellenicaExcludedTaxonImport.class,
                 FloraHellenicaSynonymImport.class,
                 FloraHellenicaCommentsImport.class,
+                FloraHellenicaImageImport.class,
         };
     }
+
+
+    public boolean isDoImages() {
+        return isDoImages;
+    }
+
+
+    public void setDoImages(boolean isDoImages) {
+        this.isDoImages = isDoImages;
+    }
 }
diff --git a/cdm-eflora/src/main/java/eu/etaxonomy/cdm/app/eflora/CdmDestinations.java b/cdm-eflora/src/main/java/eu/etaxonomy/cdm/app/eflora/CdmDestinations.java
index 0570b2d5..abfd0451 100644
--- a/cdm-eflora/src/main/java/eu/etaxonomy/cdm/app/eflora/CdmDestinations.java
+++ b/cdm-eflora/src/main/java/eu/etaxonomy/cdm/app/eflora/CdmDestinations.java
@@ -38,7 +38,7 @@ public class CdmDestinations {
 		DatabaseTypeEnum dbType = DatabaseTypeEnum.MySQL;
 		String cdmServer = "127.0.0.1";
 		String cdmDB = "cdm_test";
-		String cdmUserName = "root";
+		String cdmUserName = "edit";
 		return makeDestination(dbType, cdmServer, cdmDB, -1, cdmUserName, null);
 	}
 