commit 0c7f7de706cf544d43ff88dd70e06681c5c6ce59
Author: Patrick Plitzner <p.plitzner@bgbm.org>
Date:   Wed Oct 24 14:27:40 2018 +0200

    ref #4611 i18n for admin preferences

diff --git a/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/l10n/messages_de.properties b/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/l10n/messages_de.properties
index 3f8063438..1061a69b3 100644
--- a/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/l10n/messages_de.properties
+++ b/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/l10n/messages_de.properties
@@ -13,6 +13,12 @@ LanguageEditorPreferencePage_ChooseDefaultLanguage=Bitte w
 LanguageEditorPreferencePage_EditorHasToRestart=Der Anwendung muss neu gestartet werden, um die Sprache zu wechseln.\nWollen Sie jetzt neu starten?
 LanguageEditorPreferencePage_PleaseRestart=Bitte neu starten
 LanguageEditorPreferencePage_RestartRequired=Nach dem Wechsel der Standardsprache ist ein Neustart erforderlich.
+ListComponent_ADD_PROVIDER=Provider hinzufügen
+ListComponent_NO_PROVIDER_AVAILABLE=Keine Provider verfügbar
+ListComponent_REMOVE_PROVIDER=Provider entfernen
+OpenCommonNameAreaWizardAdminHandler_COMMON_NAMES=Trivialnamen
+OpenDistributionEditorWizardHandlerAdminE4_DISTRIBUTION=Verbreitung
+OpenDistributionEditorWizardHandlerE4_DISTRIBUTION=Verbreitung
 OrderPreferencePage_NewNavigatorWindowRequired=Nach dem Ändern der Taxon Sortierung, ist das Schließen und erneute Öffnen des Taxonnavigators erforderlich.
 OrderPreferencePage_PleaseReopenNavigator=Bitte schließen Sie den Taxonnavigator und öffnen ihn erneut.
 DatabaseRepairPage_chooseParameter=Bitte wählen Sie, für welche Bäume der SortIndex neu berechnet werden soll.
@@ -312,6 +318,22 @@ AbcdImportPreference_allow_override=Erlaube 
 AbcdImportPreference_allow_override_tooltip=Es dürfen lokale Änderungen an den Präferenzen vorgenommen werden.
 
 AbcdImportProvider_description=Konfiguration einer Liste von Biocase Providern für die Specimen Suche
+AvailableAreaVocabulariesPage_PAGE_DESCRIPTION=Um %s von Taxa anzuzeigen oder zu bearbeiten,\nmuss das Vokabular ausgewählt werden, von dem die Gebiete ausgewählt werden sollen.
+AvailableAreaVocabulariesPage_PAGE_TITLE=Vokabular für %s auswählen
+AvailableDistributionPage_CHECK_MESSAGE=Bitte wählen Sie mindestens einen Eintrag aus
+AvailableDistributionPage_PAGE_DESCRIPTION=Um den Verbreitungsstatus von Taxa anzuzeigen und zu bearbeiten,\n muss das Gebiet ausgewählt werden, dass angezeigt/bearbeitet werden soll.
+AvailableDistributionPage_PAGE_TITLE=Auswahl der Gebiete für den Verbreitungs-Editor
+AvailableDistributionStatusPage_PAGE_DESCRIPTION=Um den Verbreitungsstatus für Taxa in einem bestimmten Gebiet zu bearbeiten,\nkönnen Sie die Liste der verfügbare Status auswählen.
+AvailableDistributionStatusPage_PAGE_TITLE=Verbreitungsstatus auswählen
+AvailableDistributionStatusWizard_PAGE_TITLE=Verfügbare Verbreitungsstatus
+AvailableDistributionStatusWizard_WINDOW_TITLE=Verbreitungsstatus auswählen
+AvailableDistributionStatusWizard_WIZARD_TITLE=Verbreitungsstatus auswählen
+AvailableDistributionWizard_CHECK_MESSAGE=Bitte wählen Sie mindestens einen Eintrag aus
+AvailableDistributionWizard_PAGE_TITLE=Verfügbare Verbreitungsgebiete
+AvailableDistributionWizard_WINDOW_TITLE=Verbreitung auswählen
+AvailableVocabularyWizard_PAGE_TITLE=Verbreitung auswählen
+AvailableVocabularyWizard_WINDOW_TITLE=Vokabular auswählen
+AvailableVocabularyWizard_WIZARD_TITLE=Vokabular auswählen
 
 ChecklistEditorGeneralPreference_3=eu.etaxonomy.taxeditor.store.open.OpenDistributionEditorWizardHandler
 ChecklistEditorGeneralPreference_enable=Verbreitungs-Editor aktivieren
@@ -326,6 +348,7 @@ ChecklistEditorGeneralPreference_show_title=Vollst
 ChecklistEditorGeneralPreference_show_rank=Rang anzeigen
 ChecklistEditorGeneralPreference_show_symbol=Symbol des Status anzeigen, wenn es existiert
 ChecklistEditorGeneralPreference_sort_areas=Areas nach der Sortierung im Vokabular anzeigen
+ChecklistEditorGeneralPreference_STATUS_DISPLAY_TEXT=Einstellung für die Anzeige des Status
 GfBioTerminologyImportPresenter_NO_CONNECTION_MESSAGE=Konnte keine Verbindung zum Webservice herstellen.
 GfBioTerminologyImportPresenter_NO_CONNECTION_TITLE=Webservice nicht erreichbar
 GfBioTerminologyImportPresenter_NO_RESULTS_MESSAGE=Keine Ergebnisse für die Anfrage gefunden.
@@ -343,9 +366,8 @@ PublishFlagPreference_set=Publish Flag setzen
 NomenclaturalCodePreferences_available_codes=Verfügbare Codes
 NomenclaturalCodePreferences_description=Konfiguration des verwendeten Nomenklatorischen Codes beim Erstellen eines neuen Taxons
 
-NameRelationshipWizardPage_description=Auswahl des Relationstyps und des in Beziehung stehenden Namens 
-
 NameDetailsViewConfiguration_description=Konfiguration eines vereinfachten Namensdetailsviews. \nDie ausgewählten Parts werden angezeigt, die anderen sind nicht sichtbar.
+NameRelationshipWizardPage_description=Auswahl des Relationstyps und des in Beziehung stehenden Namens 
 
 DateDetail_parseText_tooltip=Dieses Feld ist für die schnelle Dateneingabe. Der Inhalt des Feldes wird geparsed und in die atomisierten Felder geschrieben. Der Inhalt des Feldes selber wird nicht gespeichert.
 
@@ -359,3 +381,4 @@ Distribution_status_selection=Status Auswahl
 DatabasePreferncesPage_Show_MediaView=Zeige den Media View an
 DatabasePreferncesPage_Show_ChecklistPerspective=Zeige Checklist Perspektive als Default Perspektive an
 DatabasePreferncesPage_Show_TaxonNodeWizard=Wizard zum Editieren der Taxon Knoten anzeigen
+DistributionAdminPreferences_SELECT_STATUS=Wählen Sie den Status, der für die Verbreitungsdaten verfügbar sein soll.