commit 767ce19d9383c066153ff8534983bc320547c896
Author: Andreas Müller <a.mueller@bgbm.org>
Date:   Wed Jul 15 20:32:15 2020 +0200

    cleanup

diff --git a/app-import/src/main/java/eu/etaxonomy/cdm/app/caryophyllales/CaryophyllalesTcsXmlActivator.java b/app-import/src/main/java/eu/etaxonomy/cdm/app/caryophyllales/CaryophyllalesTcsXmlActivator.java
index 5a9e3e3a..26bee0a3 100644
--- a/app-import/src/main/java/eu/etaxonomy/cdm/app/caryophyllales/CaryophyllalesTcsXmlActivator.java
+++ b/app-import/src/main/java/eu/etaxonomy/cdm/app/caryophyllales/CaryophyllalesTcsXmlActivator.java
@@ -24,8 +24,8 @@ import eu.etaxonomy.cdm.io.common.IImportConfigurator.DO_REFERENCES;
 import eu.etaxonomy.cdm.io.tcsxml.in.TcsXmlImportConfigurator;
 
 /**
- * @author a.mueller
- * @since 20.06.2008
+ * @author k.luther
+ * @since 2014
  */
 public class CaryophyllalesTcsXmlActivator {
 	private static final Logger logger = Logger.getLogger(CaryophyllalesTcsXmlActivator.class);
@@ -57,8 +57,6 @@ public class CaryophyllalesTcsXmlActivator {
 	static final boolean doTaxa = true;
 	static final boolean doRelTaxa = true;
 
-
-
 	private void doImport(){
 		System.out.println("Start import from Tcs("+ tcsSource.toString() + ") ...");
 
@@ -86,12 +84,10 @@ public class CaryophyllalesTcsXmlActivator {
 			tcsImportConfigurator.setDoGetMissingNames(doGetMissingNames);
 
 			// invoke import
-			CdmDefaultImport<TcsXmlImportConfigurator> tcsImport = new CdmDefaultImport<TcsXmlImportConfigurator>();
+			CdmDefaultImport<TcsXmlImportConfigurator> tcsImport = new CdmDefaultImport<>();
 			//new Test().invoke(tcsImportConfigurator);
 			tcsImport.invoke(tcsImportConfigurator);
 
-
-
 //			IReferenceService refService = tcsImport.getCdmAppController().getReferenceService();
 //			IBook book = ReferenceFactory.newBook();
 //			book.setDatePublished(TimePeriod.NewInstance(1945).setEndDay(12).setEndMonth(4));
@@ -106,15 +102,10 @@ public class CaryophyllalesTcsXmlActivator {
 		} catch (URISyntaxException e) {
 			e.printStackTrace();
 		}
-
 	}
 
-	/**
-	 * @param args
-	 */
 	public static void main(String[] args) {
 		CaryophyllalesTcsXmlActivator me = new CaryophyllalesTcsXmlActivator();
 		me.doImport();
 	}
-
 }
diff --git a/app-import/src/main/java/eu/etaxonomy/cdm/app/caryophyllales/CdmLightExportActivator.java b/app-import/src/main/java/eu/etaxonomy/cdm/app/caryophyllales/CdmLightExportActivator.java
index ad8e625d..ff9d50a2 100644
--- a/app-import/src/main/java/eu/etaxonomy/cdm/app/caryophyllales/CdmLightExportActivator.java
+++ b/app-import/src/main/java/eu/etaxonomy/cdm/app/caryophyllales/CdmLightExportActivator.java
@@ -30,7 +30,6 @@ import eu.etaxonomy.cdm.io.common.ExportResultType;
 /**
  * @author k.luther
  * @since 24.03.2017
- *
  */
 public class CdmLightExportActivator {
 private static final ICdmDataSource cdmSource = CdmDestinations.cdm_local_caryophyllales_nepenthaceae();
diff --git a/app-import/src/main/java/eu/etaxonomy/cdm/app/caryophyllales/DeleteNonReferencedReferences.java b/app-import/src/main/java/eu/etaxonomy/cdm/app/caryophyllales/DeleteNonReferencedReferences.java
index 8a79a936..7f450a41 100644
--- a/app-import/src/main/java/eu/etaxonomy/cdm/app/caryophyllales/DeleteNonReferencedReferences.java
+++ b/app-import/src/main/java/eu/etaxonomy/cdm/app/caryophyllales/DeleteNonReferencedReferences.java
@@ -1,6 +1,13 @@
+/**
+* Copyright (C) 2017 EDIT
+* European Distributed Institute of Taxonomy
+* http://www.e-taxonomy.eu
+*
+* The contents of this file are subject to the Mozilla Public License Version 1.1
+* See LICENSE.TXT at the top of this package for the full license terms.
+*/
 package eu.etaxonomy.cdm.app.caryophyllales;
 
-
 import org.apache.log4j.Logger;
 
 import eu.etaxonomy.cdm.app.common.CdmDestinations;
@@ -10,7 +17,10 @@ import eu.etaxonomy.cdm.io.common.CdmDefaultImport;
 import eu.etaxonomy.cdm.io.common.ImportResult;
 import eu.etaxonomy.cdm.io.operation.config.DeleteNonReferencedReferencesConfigurator;
 
-
+/**
+ * @author k.luther
+ * @since 2015
+ */
 public class DeleteNonReferencedReferences {
 
 		@SuppressWarnings("unused")
diff --git a/app-import/src/main/java/eu/etaxonomy/cdm/app/common/CdmDestinations.java b/app-import/src/main/java/eu/etaxonomy/cdm/app/common/CdmDestinations.java
index 7552e6d5..373a2688 100644
--- a/app-import/src/main/java/eu/etaxonomy/cdm/app/common/CdmDestinations.java
+++ b/app-import/src/main/java/eu/etaxonomy/cdm/app/common/CdmDestinations.java
@@ -510,8 +510,8 @@ public class CdmDestinations {
 	public static ICdmDataSource cdm_local_caryo(){
 		DatabaseTypeEnum dbType = DatabaseTypeEnum.MySQL;
 		String cdmServer = "127.0.0.1";
-		String cdmDB = "cdm_local_caryophyllales";
-		String cdmUserName = "root";
+		String cdmDB = "cdm_caryo_spp";
+		String cdmUserName = "edit";
 		return makeDestination(dbType, cdmServer, cdmDB, -1, cdmUserName, null);
 	}
 