commit 781c088070cf405452780604dc9358046e0c35e8
Author: Andreas Müller <a.mueller@bgbm.org>
Date:   Fri Sep 30 17:00:49 2022 +0200

    fix #10163 fix labels for "Orthography Conserved" and "Conserved Desig"

diff --git a/cdmlib-model/src/main/java/eu/etaxonomy/cdm/model/metadata/CdmMetaData.java b/cdmlib-model/src/main/java/eu/etaxonomy/cdm/model/metadata/CdmMetaData.java
index 3c1631b769..5ab29f9e86 100644
--- a/cdmlib-model/src/main/java/eu/etaxonomy/cdm/model/metadata/CdmMetaData.java
+++ b/cdmlib-model/src/main/java/eu/etaxonomy/cdm/model/metadata/CdmMetaData.java
@@ -74,7 +74,8 @@ public class CdmMetaData extends CdmBase{
         V_05_27_00("5.27.0.0.20210913"),
         V_05_27_01("5.27.1.0.20210922"),
         V_05_29_00("5.29.0.0.20211122"),
-        V_05_32_00("5.32.0.0.20220807")
+        V_05_32_00("5.32.0.0.20220807"),
+        V_05_33_00("5.33.0.0.20220807")
         ;
         private String versionString;
 	    private CdmVersion(String versionString){
diff --git a/cdmlib-persistence/src/main/java/eu/etaxonomy/cdm/database/update/v532_533/SchemaUpdater_5320_5330.java b/cdmlib-persistence/src/main/java/eu/etaxonomy/cdm/database/update/v532_533/SchemaUpdater_5320_5330.java
new file mode 100644
index 0000000000..24159a0b9e
--- /dev/null
+++ b/cdmlib-persistence/src/main/java/eu/etaxonomy/cdm/database/update/v532_533/SchemaUpdater_5320_5330.java
@@ -0,0 +1,79 @@
+/**
+ * Copyright (C) 2007 EDIT
+ * European Distributed Institute of Taxonomy
+ * http://www.e-taxonomy.eu
+ *
+ * The contents of this file are subject to the Mozilla Public License Version 1.1
+ * See LICENSE.TXT at the top of this package for the full license terms.
+ */
+package eu.etaxonomy.cdm.database.update.v532_533;
+
+import java.util.ArrayList;
+import java.util.List;
+import java.util.UUID;
+
+import org.apache.logging.log4j.LogManager;
+import org.apache.logging.log4j.Logger;
+
+import eu.etaxonomy.cdm.database.update.ISchemaUpdater;
+import eu.etaxonomy.cdm.database.update.ISchemaUpdaterStep;
+import eu.etaxonomy.cdm.database.update.SchemaUpdaterBase;
+import eu.etaxonomy.cdm.database.update.TermRepresentationUpdater;
+import eu.etaxonomy.cdm.database.update.v529_532.SchemaUpdater_5290_5320;
+import eu.etaxonomy.cdm.model.common.Language;
+import eu.etaxonomy.cdm.model.metadata.CdmMetaData.CdmVersion;
+
+/**
+ * @author a.mueller
+ * @date 30.09.2022
+ */
+public class SchemaUpdater_5320_5330 extends SchemaUpdaterBase {
+
+	@SuppressWarnings("unused")
+	private static final Logger logger = LogManager.getLogger(SchemaUpdater_5320_5330.class);
+
+	private static final CdmVersion startSchemaVersion = CdmVersion.V_05_22_00;
+	private static final CdmVersion endSchemaVersion = CdmVersion.V_05_33_00;
+
+// ********************** FACTORY METHOD *************************************
+
+	public static SchemaUpdater_5320_5330 NewInstance() {
+		return new SchemaUpdater_5320_5330();
+	}
+
+	protected SchemaUpdater_5320_5330() {
+		super(startSchemaVersion.versionString(), endSchemaVersion.versionString());
+	}
+
+    @Override
+    public ISchemaUpdater getPreviousUpdater() {
+        return SchemaUpdater_5290_5320.NewInstance();
+    }
+
+    @Override
+	protected List<ISchemaUpdaterStep> getUpdaterList() {
+
+		String stepName;
+
+		List<ISchemaUpdaterStep> stepList = new ArrayList<>();
+
+		//#10163
+        stepName = "Change label + desc. 'Conserved Desig' => 'Conservation Designated'";
+        String uuidTerm = "4e9c9702-a74d-4033-9d47-792ad123712c";
+        String description = "Conservation Designated";
+        String label = "Conservation designated";
+        String abbrev = null;
+        UUID uuidLatin = Language.uuidLatin;  //not really true but all nom. status currently use Latin representations
+        TermRepresentationUpdater.NewInstanceWithTitleCache(stepList, stepName, UUID.fromString(uuidTerm), description, label, abbrev, uuidLatin);
+
+        stepName = "Revert label + desc. for orth. cons. from incorrect 'Conservation Designated' => 'Orthography Conserved'";
+        uuidTerm = "34a7d383-988b-4117-b8c0-52b947f8c711";
+        description = "Orthography Conserved";
+        label = "Orthography Conserved";
+//        abbrev = null;
+        uuidLatin = Language.uuidLatin;  //not really true but all nom. status currently use Latin representations
+        TermRepresentationUpdater.NewInstanceWithTitleCache(stepList, stepName, UUID.fromString(uuidTerm), description, label, abbrev, uuidLatin);
+
+		return stepList;
+    }
+}
\ No newline at end of file