commit bee783cbfd60a9ed270b6d8d14f9a34bfb297dea
Author: Katja Luther <k.luther@bgbm.org>
Date:   Thu Jun 30 09:44:52 2016 +0200

    fix transient services

diff --git a/eu.etaxonomy.taxeditor.editor/src/main/java/eu/etaxonomy/taxeditor/editor/view/dataimport/transientServices/TransientAgentService.java b/eu.etaxonomy.taxeditor.editor/src/main/java/eu/etaxonomy/taxeditor/editor/view/dataimport/transientServices/TransientAgentService.java
index f740dbe2b..2fa22c3d8 100644
--- a/eu.etaxonomy.taxeditor.editor/src/main/java/eu/etaxonomy/taxeditor/editor/view/dataimport/transientServices/TransientAgentService.java
+++ b/eu.etaxonomy.taxeditor.editor/src/main/java/eu/etaxonomy/taxeditor/editor/view/dataimport/transientServices/TransientAgentService.java
@@ -846,5 +846,12 @@ public class TransientAgentService implements IAgentService {
 		 return defaultService.getUuidAndAbbrevTitleCache(limit, pattern, clazz);
 	}
 
+	@Override
+	public List<AgentBase> listByIds(Set<Integer> arg0, Integer arg1,
+			Integer arg2, List<OrderHint> arg3, List<String> arg4) {
+		
+		return defaultService.listByIds(arg0, arg1, arg2, arg3, arg4);
+	}
+
 
 }
diff --git a/eu.etaxonomy.taxeditor.editor/src/main/java/eu/etaxonomy/taxeditor/editor/view/dataimport/transientServices/TransientClassificationService.java b/eu.etaxonomy.taxeditor.editor/src/main/java/eu/etaxonomy/taxeditor/editor/view/dataimport/transientServices/TransientClassificationService.java
index e80fa3502..c06ab0872 100644
--- a/eu.etaxonomy.taxeditor.editor/src/main/java/eu/etaxonomy/taxeditor/editor/view/dataimport/transientServices/TransientClassificationService.java
+++ b/eu.etaxonomy.taxeditor.editor/src/main/java/eu/etaxonomy/taxeditor/editor/view/dataimport/transientServices/TransientClassificationService.java
@@ -46,6 +46,7 @@ import eu.etaxonomy.cdm.model.taxon.TaxonNode;
 import eu.etaxonomy.cdm.model.view.AuditEvent;
 import eu.etaxonomy.cdm.model.view.AuditEventRecord;
 import eu.etaxonomy.cdm.persistence.dao.common.AuditEventSort;
+import eu.etaxonomy.cdm.persistence.dto.ClassificationLookupDTO;
 import eu.etaxonomy.cdm.persistence.dto.MergeResult;
 import eu.etaxonomy.cdm.persistence.dto.UuidAndTitleCache;
 import eu.etaxonomy.cdm.persistence.query.Grouping;
@@ -1016,5 +1017,18 @@ public class TransientClassificationService implements IClassificationService {
 		return defaultService.pageSiblingsOfTaxon(taxonUuid, classificationUuid, pageSize, pageIndex, propertyPaths);
 	}
 
+	@Override
+	public List<Classification> listByIds(Set<Integer> arg0, Integer arg1,
+			Integer arg2, List<OrderHint> arg3, List<String> arg4) {
+		
+		return listByIds(arg0, arg1, arg2, arg3, arg4);
+	}
+
+	@Override
+	public ClassificationLookupDTO classificationLookup(Classification arg0) {
+		
+		return defaultService.classificationLookup(arg0);
+	}
+
 
 }
diff --git a/eu.etaxonomy.taxeditor.editor/src/main/java/eu/etaxonomy/taxeditor/editor/view/dataimport/transientServices/TransientCollectionService.java b/eu.etaxonomy.taxeditor.editor/src/main/java/eu/etaxonomy/taxeditor/editor/view/dataimport/transientServices/TransientCollectionService.java
index 990beafb6..7ca4d3d89 100644
--- a/eu.etaxonomy.taxeditor.editor/src/main/java/eu/etaxonomy/taxeditor/editor/view/dataimport/transientServices/TransientCollectionService.java
+++ b/eu.etaxonomy.taxeditor.editor/src/main/java/eu/etaxonomy/taxeditor/editor/view/dataimport/transientServices/TransientCollectionService.java
@@ -753,6 +753,13 @@ public class TransientCollectionService implements ICollectionService {
 		return defaultService.getUuidAndTitleCache(limit, pattern);
 	}
 
+	@Override
+	public List<Collection> listByIds(Set<Integer> arg0, Integer arg1,
+			Integer arg2, List<OrderHint> arg3, List<String> arg4) {
+		
+		return listByIds(arg0, arg1, arg2, arg3, arg4);
+	}
+
 
 
 }
diff --git a/eu.etaxonomy.taxeditor.editor/src/main/java/eu/etaxonomy/taxeditor/editor/view/dataimport/transientServices/TransientDescriptionService.java b/eu.etaxonomy.taxeditor.editor/src/main/java/eu/etaxonomy/taxeditor/editor/view/dataimport/transientServices/TransientDescriptionService.java
index a26c55393..f1d24b78d 100644
--- a/eu.etaxonomy.taxeditor.editor/src/main/java/eu/etaxonomy/taxeditor/editor/view/dataimport/transientServices/TransientDescriptionService.java
+++ b/eu.etaxonomy.taxeditor.editor/src/main/java/eu/etaxonomy/taxeditor/editor/view/dataimport/transientServices/TransientDescriptionService.java
@@ -1238,5 +1238,12 @@ public class TransientDescriptionService implements IDescriptionService {
 		return defaultService.getUuidAndTitleCache(limit, pattern);
 	}
 
+	@Override
+	public List<DescriptionBase> listByIds(Set<Integer> arg0, Integer arg1,
+			Integer arg2, List<OrderHint> arg3, List<String> arg4) {
+		
+		return defaultService.listByIds(arg0, arg1, arg2, arg3, arg4);
+	}
+
 
 }
diff --git a/eu.etaxonomy.taxeditor.editor/src/main/java/eu/etaxonomy/taxeditor/editor/view/dataimport/transientServices/TransientNameService.java b/eu.etaxonomy.taxeditor.editor/src/main/java/eu/etaxonomy/taxeditor/editor/view/dataimport/transientServices/TransientNameService.java
index cb0ab1b04..f9ff627df 100644
--- a/eu.etaxonomy.taxeditor.editor/src/main/java/eu/etaxonomy/taxeditor/editor/view/dataimport/transientServices/TransientNameService.java
+++ b/eu.etaxonomy.taxeditor.editor/src/main/java/eu/etaxonomy/taxeditor/editor/view/dataimport/transientServices/TransientNameService.java
@@ -1231,4 +1231,10 @@ public class TransientNameService implements INameService {
 		return defaultService.getUuidAndTitleCacheOfNames(limit, pattern);
 	}
 
+	@Override
+	public List<TaxonNameBase> listByIds(Set<Integer> arg0, Integer arg1,
+			Integer arg2, List<OrderHint> arg3, List<String> arg4) {
+		return defaultService.listByIds(arg0, arg1, arg2, arg3, arg4);
+	}
+
 }
diff --git a/eu.etaxonomy.taxeditor.editor/src/main/java/eu/etaxonomy/taxeditor/editor/view/dataimport/transientServices/TransientOccurenceService.java b/eu.etaxonomy.taxeditor.editor/src/main/java/eu/etaxonomy/taxeditor/editor/view/dataimport/transientServices/TransientOccurenceService.java
index d742c926d..9162cc2ab 100644
--- a/eu.etaxonomy.taxeditor.editor/src/main/java/eu/etaxonomy/taxeditor/editor/view/dataimport/transientServices/TransientOccurenceService.java
+++ b/eu.etaxonomy.taxeditor.editor/src/main/java/eu/etaxonomy/taxeditor/editor/view/dataimport/transientServices/TransientOccurenceService.java
@@ -1104,4 +1104,11 @@ public class TransientOccurenceService implements IOccurrenceService {
 		return defaultService.getUuidAndTitleCache(limit, pattern);
 	}
 
+	@Override
+	public List<SpecimenOrObservationBase> listByIds(Set<Integer> arg0,
+			Integer arg1, Integer arg2, List<OrderHint> arg3, List<String> arg4) {
+		
+		return defaultService.listByIds(arg0, arg1, arg2, arg3, arg4);
+	}
+
 }
diff --git a/eu.etaxonomy.taxeditor.editor/src/main/java/eu/etaxonomy/taxeditor/editor/view/dataimport/transientServices/TransientReferenceService.java b/eu.etaxonomy.taxeditor.editor/src/main/java/eu/etaxonomy/taxeditor/editor/view/dataimport/transientServices/TransientReferenceService.java
index d985d1d81..aff289516 100644
--- a/eu.etaxonomy.taxeditor.editor/src/main/java/eu/etaxonomy/taxeditor/editor/view/dataimport/transientServices/TransientReferenceService.java
+++ b/eu.etaxonomy.taxeditor.editor/src/main/java/eu/etaxonomy/taxeditor/editor/view/dataimport/transientServices/TransientReferenceService.java
@@ -689,8 +689,8 @@ public class TransientReferenceService implements IReferenceService {
 	@Override
 	public DeleteResult isDeletable(Reference object,
 			DeleteConfiguratorBase config) {
-		// TODO Auto-generated method stub
-		return null;
+		
+		return defaultService.isDeletable(object, config);
 	}
 
 	@Override
@@ -765,4 +765,11 @@ public class TransientReferenceService implements IReferenceService {
 		return defaultService.getUuidAndTitleCache(limit, pattern);
 	}
 
+	@Override
+	public List<Reference> listByIds(Set<Integer> arg0, Integer arg1,
+			Integer arg2, List<OrderHint> arg3, List<String> arg4) {
+		
+		return defaultService.listByIds(arg0, arg1, arg2, arg3, arg4);
+	}
+
 }
diff --git a/eu.etaxonomy.taxeditor.editor/src/main/java/eu/etaxonomy/taxeditor/editor/view/dataimport/transientServices/TransientTaxonService.java b/eu.etaxonomy.taxeditor.editor/src/main/java/eu/etaxonomy/taxeditor/editor/view/dataimport/transientServices/TransientTaxonService.java
index c09b51ad7..435bdc9ff 100644
--- a/eu.etaxonomy.taxeditor.editor/src/main/java/eu/etaxonomy/taxeditor/editor/view/dataimport/transientServices/TransientTaxonService.java
+++ b/eu.etaxonomy.taxeditor.editor/src/main/java/eu/etaxonomy/taxeditor/editor/view/dataimport/transientServices/TransientTaxonService.java
@@ -1550,5 +1550,12 @@ public class TransientTaxonService implements ITaxonService {
 		return defaultService.getUuidAndTitleCacheSynonym(limit, pattern);
 	}
 
+	@Override
+	public List<TaxonBase> listByIds(Set<Integer> arg0, Integer arg1,
+			Integer arg2, List<OrderHint> arg3, List<String> arg4) {
+		
+		return defaultService.listByIds(arg0, arg1, arg2, arg3, arg4);
+	}
+
 
 }
diff --git a/eu.etaxonomy.taxeditor.editor/src/main/java/eu/etaxonomy/taxeditor/editor/view/dataimport/transientServices/TransientTermService.java b/eu.etaxonomy.taxeditor.editor/src/main/java/eu/etaxonomy/taxeditor/editor/view/dataimport/transientServices/TransientTermService.java
index c904025c9..19ef7de34 100644
--- a/eu.etaxonomy.taxeditor.editor/src/main/java/eu/etaxonomy/taxeditor/editor/view/dataimport/transientServices/TransientTermService.java
+++ b/eu.etaxonomy.taxeditor.editor/src/main/java/eu/etaxonomy/taxeditor/editor/view/dataimport/transientServices/TransientTermService.java
@@ -918,4 +918,11 @@ public class TransientTermService implements ITermService {
 			Integer limit, String pattern) {
 		return defaultService.getUuidAndTitleCache(limit, pattern);
 	}
+
+	@Override
+	public List<DefinedTermBase> listByIds(Set<Integer> arg0, Integer arg1,
+			Integer arg2, List<OrderHint> arg3, List<String> arg4) {
+		
+		return defaultService.listByIds(arg0, arg1, arg2, arg3, arg4);
+	}
 }